#include <pspctrl.h> 
#include <math.h>

#include <pspdebug.h>

int getCode(int i){
/* Translates codes from pad to appropiate characters or control codes */
	switch(i){
			
		case 1: {return 'a'; break;} // pad left
		case 2: {return 'b'; break;} // pad left-up
		case 3: {return 'c'; break;} // pad up
		case 4: {return 'd'; break;} // pad right-up
		case 5: {return 'e'; break;} // pad right
		case 6: {return 'f'; break;} // pad right-down
		case 7: {return 'g'; break;} // pad down
		case 8: {return 'h'; break;} // pad left-down
		
		case 9: {return -10; break;} // start - change from/to command mode
		case 10: {return -1; break;} // select
		case 11: {return -12; break;} // right - ' '
		case 12: {return -13; break;} // up - mode change
		case 13: {return -14; break;} // left - '\b'
		case 14: {return -15; break;} // down - '\n'
		case 15: {return -1; break;} // circle
		case 16: {return -1; break;} // triangle
		case 17: {return -1; break;} // square
		case 18: {return -1; break;} // cross
		
		case 19: {return -20; break;} // only left trigger
			 
		case 20: {return 'i'; break;} // same as previous + left trigger
		case 21: {return 'j'; break;}
		case 22: {return 'k'; break;}
		case 23: {return 'l'; break;}
		case 24: {return 'm'; break;}
		case 25: {return 'n'; break;}
		case 26: {return 'o'; break;}
		case 27: {return 'p'; break;}
				 
		case 28: {return -1; break;}
		case 29: {return -1; break;}
		case 30: {return -31; break;}
		case 31: {return -32; break;}
		case 32: {return -33; break;}
		case 33: {return -34; break;}
		case 34: {return -1; break;}
		case 35: {return -1; break;}
		case 36: {return -1; break;}
		case 37: {return -1; break;}
	
		case 38: {return -39; break;} // only right trigger
			 
		case 39: {return 'q'; break;} // + right trigger
		case 40: {return 'r'; break;}
		case 41: {return 's'; break;}
		case 42: {return 't'; break;}
		case 43: {return 'u'; break;}
		case 44: {return 'v'; break;}
		case 45: {return 'w'; break;}
		case 46: {return 'x'; break;}
		
		case 47: {return -1; break;}
		case 48: {return -1; break;}
		case 49: {return -1; break;}
		case 50: {return -1; break;}
		case 51: {return -1; break;}
		case 52: {return -1; break;}
		case 53: {return -1; break;}
		case 54: {return -1; break;}
		case 55: {return -1; break;}
		case 56: {return -1; break;}
	
		case 57: {return -58; break;} // only both triggers
			 
		case 58: {return 'y'; break;} // + both triggers
		case 59: {return 'z'; break;}
		case 60: {return '.'; break;}
		case 61: {return ','; break;}
		case 62: {return ':'; break;}
		case 63: {return ';'; break;}
		case 64: {return '?'; break;}
		case 65: {return '/'; break;}
		
		case 66: {return -1; break;}
		case 67: {return -1; break;}
		case 68: {return -1; break;}
		case 69: {return -1; break;}
		case 70: {return -1; break;}
		case 71: {return -1; break;}
		case 72: {return -1; break;}
		case 73: {return -1; break;}
		case 74: {return -1; break;}
		case 75: {return -1; break;}
		
		// END OF MODE 0
			
		case 76: {return '0'; break;} // pad left
		case 77: {return '1'; break;} // pad left-up
		case 78: {return '2'; break;} // pad up
		case 79: {return '3'; break;} // pad right-up
		case 80: {return '4'; break;} // pad right
		case 81: {return '5'; break;} // pad right-down
		case 82: {return '6'; break;} // pad down
		case 83: {return '7'; break;} // pad left-down
		
		case 84: {return -10; break;} // start - change from/to command mode
		case 85: {return -1; break;} // select
		case 86: {return -12; break;} // right - ' '
		case 87: {return -13; break;} // up - mode change
		case 88: {return -14; break;} // left - '\b'
		case 89: {return -15; break;} // down - '\n'
		case 90: {return -1; break;} // circle
		case 91: {return -1; break;} // triangle
		case 92: {return -1; break;} // square
		case 93: {return -1; break;} // cross
		
		case 94: {return -20; break;} // only left trigger
			 
		case 95: {return '8'; break;} // same as previous + left trigger
		case 96: {return '9'; break;}
		case 97: {return '!'; break;}
		case 98: {return '"'; break;}
		case 99: {return '@'; break;}
		case 100: {return '$'; break;}
		case 101: {return '%'; break;}
		case 102: {return '&'; break;}
				 
		case 103: {return -1; break;}
		case 104: {return -1; break;}
		case 105: {return -1; break;}
		case 106: {return -1; break;}
		case 107: {return -1; break;}
		case 108: {return -1; break;}
		case 109: {return -1; break;}
		case 110: {return -1; break;}
		case 111: {return -1; break;}
		case 112: {return -1; break;}
	
		case 113: {return -39; break;} // only right trigger
			 
		case 114: {return '/'; break;} // + right trigger
		case 115: {return '('; break;}
		case 116: {return ')'; break;}
		case 117: {return '='; break;}
		case 118: {return '\''; break;}
		case 119: {return '?'; break;}
		case 120: {return '<'; break;}
		case 121: {return '>'; break;}
		
		case 122: {return -1; break;}
		case 123: {return -1; break;}
		case 124: {return -1; break;}
		case 125: {return -1; break;}
		case 126: {return -1; break;}
		case 127: {return -1; break;}
		case 128: {return -1; break;}
		case 129: {return -1; break;}
		case 130: {return -1; break;}
		case 131: {return -1; break;}
	
		case 132: {return -58; break;} // only both triggers
			 
		case 133: {return '['; break;} // + both triggers
		case 134: {return ']'; break;}
		case 135: {return '{'; break;}
		case 136: {return '}'; break;}
		case 137: {return '^'; break;}
		case 138: {return '*'; break;}
		case 139: {return '-'; break;}
		case 140: {return '_'; break;}
		
		case 141: {return -1; break;}
		case 142: {return -1; break;}
		case 143: {return -1; break;}
		case 144: {return -1; break;}
		case 145: {return -1; break;}
		case 146: {return -1; break;}
		case 147: {return -1; break;}
		case 148: {return -1; break;}
		case 149: {return -1; break;}
		case 150: {return -1; break;}
	};
	return -1;
}

int stickZone(SceCtrlData pad){
	/* The analog stick moves inside a 256x256 square, I have divided
	 * that square into 9 zones, there is a circle with an 80 size radius
	 * that is the 0 zone, the space around it is divided in sections of
	 * 1/4 of PI radians, being the rightmost the 1 zone and continuing
	 * anti-clockwise */
	double angle;
	int zone;
	double xd = pad.Lx-128;
	double yd = pad.Ly-128;
	
	if (sqrt(pow(xd,2)+pow(yd,2)) < 80) {return 0;}; //If the distance from the stick to the center is less than 80 we are in the central zone
	angle = atan2(yd,-xd) + 1.125*M_PI; //The angle of the cursor is from 0 to 2PI radians, we add PI/8 to rotate the zones a bit
	if (angle > M_2_PI) angle = angle - M_2_PI;
	zone = floor(angle/M_PI_4) + 1;
	
	return zone;
}

int getChar(SceCtrlData pad, int charset){
	/* The left and right triggers state an offset of 8 and 16 (when
	 * both are pressed the offset is 24, of course), this offset and 
	 * the zone number are added to 96 (ascii value just before 'a')
	 * so we get 36 combinations to express letters and symbols, when
	 * the stick is in the 0 zone a False is returned to state that a
	 * character has been chosen (the one we send just prior to that
	 * False)*/
	int c; // As this is an int, it can be also used for control codes, these will be negative ones (not sure if it is a good programming practise, this one...)
	c = stickZone(pad);
	if (!c){ // If the stick is in central zone
		if (pad.Buttons){ // Check for buttons
			if (pad.Buttons & PSP_CTRL_START) c = 9; // Switch to command mode, vi style
			if (pad.Buttons & PSP_CTRL_SELECT) c = 10;
			if (pad.Buttons & PSP_CTRL_RIGHT) c = 11;
			if (pad.Buttons & PSP_CTRL_UP) c = 12;
			if (pad.Buttons & PSP_CTRL_LEFT) c = 13;
			if (pad.Buttons & PSP_CTRL_DOWN) c = 14;
			if (pad.Buttons & PSP_CTRL_CIRCLE) c = 15;
			if (pad.Buttons & PSP_CTRL_TRIANGLE) c = 16;
			if (pad.Buttons & PSP_CTRL_SQUARE) c = 17;
			if (pad.Buttons & PSP_CTRL_CROSS) c = 18;
		}
		else { // If stick in central zone and no buttons pressed, return write order
			return 0;
		}
	}
	else c = c + charset * 75; // Only if we are trying to write we consider the charset to use
	
	if (pad.Buttons & PSP_CTRL_LTRIGGER) c = c + 19; // Check trigger modifiers 
	if (pad.Buttons & PSP_CTRL_RTRIGGER) c = c + 38;
	return getCode(c); // Translate into a char or command 
}

